// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_sensor_msgs:msg/Gyro.idl
// generated code does not contain a copyright notice
#include "marti_sensor_msgs/msg/detail/gyro__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
marti_sensor_msgs__msg__Gyro__init(marti_sensor_msgs__msg__Gyro * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_sensor_msgs__msg__Gyro__fini(msg);
    return false;
  }
  // angular_rate
  // variance
  return true;
}

void
marti_sensor_msgs__msg__Gyro__fini(marti_sensor_msgs__msg__Gyro * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // angular_rate
  // variance
}

marti_sensor_msgs__msg__Gyro *
marti_sensor_msgs__msg__Gyro__create()
{
  marti_sensor_msgs__msg__Gyro * msg = (marti_sensor_msgs__msg__Gyro *)malloc(sizeof(marti_sensor_msgs__msg__Gyro));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_sensor_msgs__msg__Gyro));
  bool success = marti_sensor_msgs__msg__Gyro__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_sensor_msgs__msg__Gyro__destroy(marti_sensor_msgs__msg__Gyro * msg)
{
  if (msg) {
    marti_sensor_msgs__msg__Gyro__fini(msg);
  }
  free(msg);
}


bool
marti_sensor_msgs__msg__Gyro__Sequence__init(marti_sensor_msgs__msg__Gyro__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_sensor_msgs__msg__Gyro * data = NULL;
  if (size) {
    data = (marti_sensor_msgs__msg__Gyro *)calloc(size, sizeof(marti_sensor_msgs__msg__Gyro));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_sensor_msgs__msg__Gyro__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_sensor_msgs__msg__Gyro__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_sensor_msgs__msg__Gyro__Sequence__fini(marti_sensor_msgs__msg__Gyro__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_sensor_msgs__msg__Gyro__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_sensor_msgs__msg__Gyro__Sequence *
marti_sensor_msgs__msg__Gyro__Sequence__create(size_t size)
{
  marti_sensor_msgs__msg__Gyro__Sequence * array = (marti_sensor_msgs__msg__Gyro__Sequence *)malloc(sizeof(marti_sensor_msgs__msg__Gyro__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_sensor_msgs__msg__Gyro__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_sensor_msgs__msg__Gyro__Sequence__destroy(marti_sensor_msgs__msg__Gyro__Sequence * array)
{
  if (array) {
    marti_sensor_msgs__msg__Gyro__Sequence__fini(array);
  }
  free(array);
}
